module Rails
  class App
    def env_config; {} end
    def routes
      return @routes if defined?(@routes)
      @routes = ActionDispatch::Routing::RouteSet.new
      @routes.draw do
        resource :named_segue, only: [] do
          collection do
            get :segue_start_page, :normal_page, :segue_complete_page, :segue_clear_page,
               :second_segue_start_page, :segue_complete_last_page
          end
        end
      end
      @routes
    end
  end
  def self.application
    @app ||= App.new
  end
end

class NamedSeguesController < ActionController::Base
  include Rails.application.routes.url_helpers

  register_segue action: :segue_start_page, as: :named_segue
  register_segue action: :second_segue_start_page, as: :another_segue

  def segue_start_page
    render text: "Start page"
  end

  def normal_page
    render text: "Normal page"
  end

  def segue_complete_page
    redirect_to complete_segue_url(:named_segue, fallback: { action: :normal_page })
  end

  def segue_clear_page
    clear_segue :named_segue
    render text: "Clear page"
  end

  def second_segue_start_page
    render text: "Second start page"
  end

  def segue_complete_last_page
    redirect_to complete_current_segue_url(fallback: { action: :normal_page })
  end

end
